#include <usbdrv.h>
#include <TM1637.h>

#define RQ_SET_LED    0
#define RQ_GET_SWITCH 2
#define RQ_GET_LIGHT  3
#define RQ_SET_SCORE  4

#define CLK PIN_PB0
#define DIO PIN_PB2
TM1637 Display1(CLK, DIO);
//////////////////////////////////////////////////////////////////////
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;
  static uint8_t switch_state;
  static uint16_t light_value;

  if (rq->bRequest == RQ_SET_LED)
  {
    uint8_t led_val = rq->wValue.bytes[0];
    uint8_t led_no  = rq->wIndex.bytes[0];

    if (led_no == 0)
      digitalWrite(PIN_PC0, led_val);
    else if (led_no == 1)
      digitalWrite(PIN_PC1, led_val);
    else if (led_no == 2)
      digitalWrite(PIN_PC2, led_val);

    return 0;  // return no data back to host
  }

  else if (rq->bRequest == RQ_GET_SWITCH)
  {
    if (digitalRead(PIN_PC3) == LOW) /* switch is pressed */ 
      switch_state = 1;
    else
      switch_state = 0;

    /* point usbMsgPtr to the data to be returned to host */
    usbMsgPtr = (uint8_t*) &switch_state;

    /* return the number of bytes of data to be returned to host */
    return sizeof(switch_state);
  }


else if (rq->bRequest == RQ_GET_LIGHT)
  {
     light_value = analogRead(PIN_PC4);
        usbMsgPtr = (uchar*) &light_value;
        return sizeof(light_value);

  }

else if (rq->bRequest == RQ_SET_SCORE)
  {
    uint8_t led_val = rq->wValue.bytes[0];
    uint8_t led_no  = rq->wIndex.bytes[0];

    Display1.display(led_no, led_val);

    return 0;  // return no data back to host
  }
  
  return 0;   /* nothing to do; return no data back to host */
}

//////////////////////////////////////////////////////////////////////
void setup()
{
 Display1.init();
  Display1.set(BRIGHT_DARKEST);
Display1.point(POINT_ON);
    Display1.display(0, 0);
  Display1.display(1, 0);
  Display1.display(2, 0);
  Display1.display(3, 0);

  
    pinMode(PIN_PC0,OUTPUT);
    pinMode(PIN_PC1,OUTPUT);
    pinMode(PIN_PC2,OUTPUT);
    pinMode(PIN_PC3,INPUT_PULLUP);
    pinMode(PIN_PC4,INPUT);
    pinMode(PIN_PD3,OUTPUT);

    usbInit();

    /* enforce re-enumeration of USB devices */
    
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();
  
}

//////////////////////////////////////////////////////////////////////
void loop()
{
  usbPoll();
}
