import sys
import core
import pygame
import time
import requests

line_token = "**REDACTED FOR PRIVACY**"
line_url = 'https://notify-api.line.me/api/notify'
line_headers = {'content-type':'application/x-www-form-urlencoded','Authorization':'Bearer '+line_token}


def sendLineMessage(msg):
    r = requests.post(line_url, headers=line_headers , data = {'message':msg})
    return

from modules import *
from practicum import find_mcu_boards, McuBoard, PeriBoard
mcu = McuBoard(find_mcu_boards()[0])
peri = PeriBoard(mcu)


peri.set_score(0,0)
peri.set_score(1,0) 
peri.set_score(2,0)
peri.set_score(3,0)
        
[peri.set_led(i,0) for i in [0,1,2]]

def Button(screen, position, text, button_size=(200, 50)):
    left, top = position
    bwidth, bheight = button_size
    pygame.draw.line(screen, (150, 150, 150), (left, top), (left+bwidth, top), 5)
    pygame.draw.line(screen, (150, 150, 150), (left, top-2), (left, top+bheight), 5)
    pygame.draw.line(screen, (50, 50, 50), (left, top+bheight), (left+bwidth, top+bheight), 5)
    pygame.draw.line(screen, (50, 50, 50), (left+bwidth, top+bheight), (left+bwidth, top), 5)
    pygame.draw.rect(screen, (100, 100, 100), (left, top, bwidth, bheight))
    font = pygame.font.Font(core.FONTPATH, 30)
    text_render = font.render(text, 1, (255, 235, 205))
    return screen.blit(text_render, (left+50, top+10))


def startInterface(screen):
    clock = pygame.time.Clock()
    while True:
        screen.fill((41, 36, 33))
        
        button_3 = Button(screen, (150, 75), 'LDR')
        #button_4 = Button(screen, (150, 175), 'Sensor')
        
        button_1 = Button(screen, (150, 175), '1 Player')
        button_2 = Button(screen, (150, 275), '2 Player')
        button_5 = Button(screen, (150, 375), 'EXIT')
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            if event.type == pygame.MOUSEBUTTONDOWN:
                if button_1.collidepoint(pygame.mouse.get_pos()):
                    return 1
                if button_2.collidepoint(pygame.mouse.get_pos()):
                    return 2
                elif button_3.collidepoint(pygame.mouse.get_pos()):
                    calibrateX = calibrate(screen)
                elif button_5.collidepoint(pygame.mouse.get_pos()):
                    pygame.quit()
                    sys.exit(0)
        clock.tick(10)
        pygame.display.update()


light_min = -1
light_max = -1
isset = False

def calibrate(screen):
    global light_min
    global light_max
    clock = pygame.time.Clock()
    while True:
        screen.fill((41, 36, 33))
        if light_min == -1:
            button_1 = Button(screen, (150, 75), 'Cover')
        else:
            button_1 = Button(screen, (150, 75), str(light_min))
            
        if light_max == -1:
            button_2 = Button(screen, (150, 175), 'Remove')
        else:
            button_2 = Button(screen, (150, 175), str(light_max))
            
        button_3 = Button(screen, (150, 275), 'Finish')
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            if event.type == pygame.MOUSEBUTTONDOWN:
                if button_1.collidepoint(pygame.mouse.get_pos()): 
                    light_min = int(peri.get_light())
                    button_1 = Button(screen, (150, 75), str(light_min))
                elif button_2.collidepoint(pygame.mouse.get_pos()):    
                    light_max = int(peri.get_light())
                    button_2 = Button(screen, (150, 175), str(light_max))
                elif button_3.collidepoint(pygame.mouse.get_pos()):
                    return 0
        clock.tick(10)
        pygame.display.update()
         
def endInterface(screen, score_left, score_right):
    clock = pygame.time.Clock()
    font1 = pygame.font.Font(core.FONTPATH, 30)
    font2 = pygame.font.Font(core.FONTPATH, 20)
    msg = 'Player on left won!' if score_left > score_right else 'Player on right won!'
    sendLineMessage(msg)
    texts = [font1.render(msg, True, core.WHITE),
            font2.render('Press ESCAPE to quit.', True, core.WHITE),
            font2.render('Press ENTER to continue or play again.', True, core.WHITE)]
    positions = [[120, 200], [155, 270], [80, 300]]
    while True:
        screen.fill((41, 36, 33))
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_RETURN:
                    return
                elif event.key == pygame.K_ESCAPE:
                    sys.exit()
                    pygame.quit()
        for text, pos in zip(texts, positions):
            screen.blit(text, pos)
        clock.tick(10)
        pygame.display.update()

c = [False,False,False]
c_data = [0,0,0]
b = [False,False,False]
b_data = [0,0,0]
r = 0
def runDemo(screen):
    font = pygame.font.Font(core.FONTPATH, 50)

    game_mode = startInterface(screen)

    score_left = 0
    racket_left = Racket(core.RACKETPICPATH, 'LEFT', core)

    score_right = 0
    racket_right = Racket(core.RACKETPICPATH, 'RIGHT', core)

    ball = Ball(core.BALLPICPATH, core)
    clock = pygame.time.Clock()
    
    r = 0
    
    while True:
    
        if r == 0:
            if peri.get_switch() == True:
                pygame.quit()
                sys.exit(-1)
        else:
            r+=1
            if r>10000:
                r=0
                
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit(-1)
        screen.fill((41, 36, 33))

        pressed_keys = pygame.key.get_pressed()
        light = int(peri.get_light())
        light_average = (light_max+light_min)/2
        if pressed_keys[pygame.K_UP] or light >= light_average:
            racket_right.move('UP')
        elif pressed_keys[pygame.K_DOWN] or light < light_average:
            racket_right.move('DOWN')
        if game_mode == 2:
            if pressed_keys[pygame.K_w]:
                racket_left.move('UP')
            elif pressed_keys[pygame.K_s]:
                racket_left.move('DOWN')
        else:
            racket_left.automove(ball)

        scores = ball.move(ball, racket_left, racket_right,peri)
        score_left += scores[0]


        if scores[0] == 1:
            peri.set_score(0,int(score_left)//10)
            peri.set_score(1,int(score_left)%10)
            peri.set_score(2,int(score_right)//10)
            peri.set_score(3,int(score_right)%10)
            b[2] = True
        
            
        score_right += scores[1]
        
        if scores[1] == 1:
            peri.set_score(0,int(score_left)//10)
            peri.set_score(1,int(score_left)%10)
            peri.set_score(2,int(score_right)//10)
            peri.set_score(3,int(score_right)%10)
            c[2] = True
            
            
        if b[2] == True:
            b_data[2]+=1

         
            peri.set_led(0,1)
            if b_data[2] >= 50:
                b_data[2] = 0
                peri.set_led(0,0)
                b[2] = False
        
        
        if c[2] == True:
            c_data[2]+=1
            peri.set_led(2,1)
            if c_data[2] >= 50:
                c_data[2] = 0
                peri.set_led(2,0)
                peri.set_led(0,0)
                c[2] = False
        

        ball.draw(screen)

        racket_left.draw(screen)
        racket_right.draw(screen)


        screen.blit(font.render(" Mode  LDR", False, core.WHITE), (98, 1))


        screen.blit(font.render(str(score_left), False, core.WHITE), (150, 50))
        screen.blit(font.render(str(score_right), False, core.WHITE), (300, 50))
        if score_left == 5 or score_right == 5:
            return score_left, score_right
        clock.tick(100)
        pygame.display.update()


def main():
    pygame.init()
    pygame.mixer.init()
    screen = pygame.display.set_mode((core.WIDTH, core.HEIGHT))
    pygame.display.set_caption('By SuperTeeX')

    while True:
        score_left, score_right = runDemo(screen)
        endInterface(screen, score_left, score_right)

if __name__ == '__main__':
    main()
